<template>
  <div class="container-fluid content comments-container dsd-item d-flex flex-column my-5">
    <h2
      title="Comments"
      class="comments-header mb-lg-4"
      data-toggle="tooltip"
      data-placement="top"
      data-cy="dataset-distributions"
    >
      Comments ({{ allComments.length }})
    </h2>

    <section class="comments-list">
      <p v-if="!(allComments.length > 0)">
        This dataset has no comments so far.
      </p>
      <div v-else
        v-for="comment in allComments"
        :key="comment.id"
        class="d-flex flex-column comment-entry my-4"
        :class="{ inpublished: !comment.isPublished }"
      >
        <div class="d-flex">
          <div class="comment-user-data col-2 text-wrap">
            <p>
              <!-- <strong>{{ comment?.person?.name }}</strong> -->
              <strong>{{ comment.person.personId }}</strong>
            </p>
            <p>{{ formatDate(comment.creationDate) }}</p>
          </div>
          <div v-if="!editMode" class="comment-text col-10">
            {{ comment?.content }}
          </div>
          <textarea
            v-else
            class="comment-text col-10"
            @keyup.enter="editComment(comment.id, comment.content)"
            v-model="comment.content"
          ></textarea>
        </div>
        <div class="comment-buttons d-flex justify-content-end">
          <!-- v-if="isAuthenticated && ownerName == comment.person.name" -->
          <span
            v-if="isAuthenticated"
            class="text-right mr-1 btn btn-link"
            @click="editMode = !editMode"
            >{{ editMode ? "Cancel" : "Edit" }}</span
          >
          <!-- v-if="isAuthenticated && ownerName == comment.person.name" -->
          <span
            v-if="isAuthenticated"
            class="text-right mr-1 btn btn-link"
            @click="deleteComment(comment?.id)"
            >Delete</span
          >
          <span
            v-if="isAuthenticated && !comment.isPublished"
            class="text-right mr-1 btn btn-link"
            @click="publishComment(comment?.id)"
            >Publish</span
          >
          <span
            v-if="isOperator && comment.isPublished"
            class="text-right mr-1 btn btn-link"
            @click="unpublishComment(comment?.id)"
            >Unpublish</span
          >
        </div>
      </div>
    </section>
    <div v-if="isAuthenticated" class="form-group">
      <label class="add-comment-header d-block" for="text-area"
        >Add new comment</label
      >
      <textarea
        class="form-control"
        id="text-area"
        v-model="newComment"
        style="height: 120px;"
      ></textarea>
      <button
        class="btn btn-primary d-flex justify-content-center align-items-center ds-input comment-btn"
        type="button"
        @click="sendComment()"
        :disabled="!(newComment.trim().length > 0)"
      >
        <span>Comment</span>
        <i class="material-icons align-bottom ml-1">chat</i>
      </button>
    </div>
  </div>
</template>

<script setup>
import axios from "axios";
import { onMounted, ref, computed, getCurrentInstance } from "vue";
import { useStore } from "vuex";
// import { usePvAuth} from '@piveau/piveau-hub-ui-plugin-auth';

// const pvAuth = usePvAuth();


const { proxy } = getCurrentInstance(); // Access the Vue instance

const baseUrl = proxy.$env.content.datasetDetails.ratingServiceUrl;

const store = useStore();
const datasetID = computed(() => store.getters["datasetDetails/getID"]);

const getUserData = computed(() => store.getters["auth/getUserData"]);

// const authToken = ""
const authToken = getUserData.value.rtpToken;
const isAuthenticated = ref(authToken ? true : false);
const allComments = ref([]);
const newComment = ref("");
const editMode = ref(false);
const isOperator = ref(isAuthenticated && getUserData.value.roles.includes("operator"));
const ownerName = getUserData.value.userName;

// const authenticated = true;

const testComments = ref([
  {
    id: 9,
    person: {
      id: 1,
      personId: "User 1",
    },
    resource: {
      id: 1,
      type: {
        id: 1,
        type: "dataset",
      },
      resourceId: "7be5c893-2b38-481e-85ef-ca03189a767e",
    },
    children: [],
    content:
      "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent libero tortor, aliquam vitae iaculis ut, efficitur et ex. Integer eu feugiat ipsum, eu commodo mauris. Etiam quis lectus eros. Aenean posuere est eget bibendum tempor. Sed venenatis, sem eget volutpat vehicula, nibh purus vulputate neque, eu dapibus libero neque sed risus.",
    lang: "en",
    isPublished: true,
    level: 0,
    creationDate: "2024-11-07T16:08:25.811+00:00",
    lastUpdate: "2024-11-07T16:08:25.811+00:00",
  },
  {
    id: 25,
    person: {
      id: 2,
      personId: "User 2",
    },
    resource: {
      id: 1,
      type: {
        id: 1,
        type: "dataset",
      },
      resourceId: "7be5c893-2b38-481e-85ef-ca03189a767e",
    },
    children: [],
    content:
      "Unpublished!! Integer eu feugiat ipsum, eu commodo mauris. Etiam quis lectus eros. Aenean posuere est eget bibendum tempor. Sed venenatis, sem eget volutpat vehicula, nibh purus vulputate neque, eu dapibus libero neque sed risus.",
    lang: "en",
    isPublished: false,
    level: 0,
    creationDate: "2024-11-08T14:27:47.268+00:00",
    lastUpdate: "2024-11-08T14:28:54.873+00:00",
  },
]);

onMounted(() => {
  // GET call to get all existing comments for the current Dataset
  // console.log("roles", getUserData.value.roles)
  getComments();
});

const formatDate = (timestamp) => {
  const date = new Date(timestamp);

  const day = String(date.getDate()).padStart(2, "0");
  const month = String(date.getMonth() + 1).padStart(2, "0");
  const year = date.getFullYear();
  const hours = String(date.getHours()).padStart(2, "0");
  const minutes = String(date.getMinutes()).padStart(2, "0");

  return `${day}/${month}/${year} - ${hours}:${minutes}`;
};

// API FUNCTIONS:
function getComments() {
  axios
    .get(`${baseUrl}comments/dataset/${datasetID.value}`, {
      headers: {
        ...(authToken && { Authorization: `Bearer ${authToken}` }),
      },
    })
    .then((response) => {
      console.log("Comments received:", response.data);
      allComments.value = response.data.data;
      allComments.value.sort((a, b) => new Date(a.creationDate) - new Date(b.creationDate));
    })
    .catch((err) => console.error(err));
}

function sendComment() {
  const content = newComment.value;

  axios
    .post(
      `${baseUrl}comments`,
      { // Body
        id: datasetID.value,
        type: "dataset",
        content: content,
        lang: proxy.$route.query.locale || "en",
        parent: null,
      },
      {
        headers: {
          Authorization: `Bearer ${authToken}`,
        },
      }
    )
    .then((response) => {
      console.log("Comment sent:", response.data);
      allComments.value.push(response.data);
    })
    .catch((err) => console.error(err));
  newComment.value = "";
}

function editComment(commentId, newComment) {
  editMode.value = !editMode.value;
  axios
    .put(
      `${baseUrl}comments/${commentId}`,
      { // Body
        content: newComment,
        lang: proxy.$route.query.locale || "en",
      },
      {
        headers: {
          Authorization: `Bearer ${authToken}`,
        },
      }
    )
    .then((response) => console.log("Comment editted.", response.data))
    .catch((err) => console.error(err));
}

function deleteComment(commentId) {
  axios
    .delete(`${baseUrl}comments/${commentId}`, {
      headers: {
        Authorization: `Bearer ${authToken}`,
      },
    })
    .then((response) => {
      console.log("Comment deleted.", response.data)
      allComments.value = allComments.value.filter(e => e.id !== response.data.id )
    })
    .catch((err) => console.error(err));
}

// after reviewer checks comment, publish the comment
function publishComment(commentId) {
  axios
    .post(`${baseUrl}comments/${commentId}/publish`, {}, {
      headers: {
        Authorization: `Bearer ${authToken}`,
      },
    })
    .then((response) => {
      console.log("Comment published.", response.data)
      allComments.value.map(comment => {
        if(comment.id == response.data.id){
          comment.isPublished = true
        }
      })
    })
    .catch((err) => console.error(err));
}

function unpublishComment(commentId) {
  axios
    .post(`${baseUrl}comments/${commentId}/unpublish`, {}, {
      headers: {
        Authorization: `Bearer ${authToken}`,
      },
    })
    .then((response) => {
      console.log("Comment unpublished.", response.data)
      allComments.value.map(comment => {
        if(comment.id == response.data.id){
          comment.isPublished = false
        }
      })
    })
    .catch((err) => console.error(err));
}
</script>

<style lang="scss" scoped>
.dsd-item {
}

.comments-header {
  padding-bottom: 10px;
  // margin-bottom: 5px;
  border-bottom: 2px solid #cfdaf5;
}

.comment-entry {
  &.inpublished {
    background-color: #f6f8fa;
    opacity: 75%;
  }
  .comment-user-data {
    padding: 15px 15px;
    word-wrap: break-word;
  }
  .comment-text {
    border: 1px solid #e9eaeb;
    border-radius: 3px;
    padding: 15px 15px;
  }
}

.comment-btn {
  width: 200px;
  border-radius: 0.25rem !important;
  margin-top: 20px;
}

.add-comment-header {
  font-weight: 700;
  font-size: 20px;
  padding-bottom: 10px;
  margin-bottom: 15px;
  border-bottom: 2px solid #515560;
}
</style>
